# Contributing to AeroGear

As an open source project we are always on the lookout for community members that want to step up and help with the project. There are lots of ways to help, and this article will help you get started!

## Help Others

Have experience with mobile or HTML5 based technologies? Interested in sharing your knowledge?

If you've got ideas for the project, or want to discuss ways to improve AeroGear, join the [aerogear-dev](https://lists.jboss.org/mailman/listinfo/aerogear-dev) mailing list and share what your working on, or struggling with. For more immediate gratification join the IRC channel (#aerogear). There are are usually a good bunch of people hanging out there. Ask your questions, share your experience, or just make jokes :-)

## Found An Issue?
Have you run into an issue with one of our examples, sites, or have a suggestion? The best place to start is probably talking about it in the forums or IRC. If you've already done that, or just want to create the issue please do at [https://issues.jboss.org/browse/AGJS](https://issues.jboss.org/browse/AGJS).

We only ask that you review our [AeroGear Jira Usage and Guidelines](http://aerogear.org/docs/guides/JIRAUsage) and use your noodle! Help the community help you :-)

## Fix an Issue!

Your ready to start taking action, dig into an issue, and update some code! Excellent!!

### Communicate

The first recommended step is to communicate with the project team. This way you can get any advice, or feedback on your plans.

The best ways to do this are through:

* IRC: #aerogear @ irc.freenode.net
* Developer mailing list: [aerogear-dev](https://lists.jboss.org/mailman/listinfo/aerogear-dev)
* Project meetings: [AeroGear Community Calendar](https://www.jboss.org/aerogear/AeroGearCalendar)

### Pick your poison

If what you want to work on is already in jira, then ask to have it assigned to you (see communicate section above). If there is no jira, go ahead and make one as described above, and in the [AeroGear Jira Usage and Guidelines](http://aerogear.org/docs/guides/JIRAUsage).

### Sign the JBoss community license agreement

This is pretty standard stuff for open source. Just use your JBoss user, and pick AeroGear for the project here:

[https://cla.jboss.org](https://cla.jboss.org)

### Follow AeroGear's coding conventions and style

This link has the IDE settings, and conventions that should be followed for all AeroGear source code. Be sure to use the **aerogear** branch as it contains the correct [license and copyright information](http://aerogear.org/docs/guides/license). The aerogear branch should be the default branch.

[https://github.com/aerogear/ide-config](https://github.com/aerogear/ide-config)


### Follow AeroGear's github workflow*

Follow our document that will walk you through how to work with GitHub, and the AeroGear repositories: [AeroGear GitHub Workflow &amp; Instructions](http://aerogear.org/docs/guides/GitHubWorkflow).

### Get Fame and Applause from Everyone!!

Talk about your work, create a blog, or tweet about it using the #AeroGear hashtag!
